﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Core.Data;

namespace ListViewIncrLoad
{
    public class ViewModel
    {
        private int currentCount = 0;

        public ViewModel()
        {
            this.Items = new IncrementalLoadingCollection<Item>(this.GetMoreItems) { BatchSize = 5 };

            // Initially load the first batch.
            this.Items.LoadMoreItemsAsync(5);
        }

        public IncrementalLoadingCollection<Item> Items { get; set; }

        private async Task<IEnumerable<Item>> GetMoreItems(uint count)
        {
            await Task.Delay(100);
            var result = Enumerable.Range(this.currentCount, (int)count).Select(x => new Item { Text = "item " + x }).ToList();
            currentCount += (int)count;
            return result;
        }
    }

    public class Item
    {
        public string Text { get; set; }
    }
}
